/*
  RotaryEncoder

  Read a rotary encoder with interrupts
  Read the press action with digitalread
  Encoder&Switch hooked up with common to +5V
  ENCODER_A_PIN to pin 2
  ENCODER_A_PIN to pin 3
  SWITCH_PIN to pin 4  


  by i3water
*/

#define ENCODER_A_PIN 2
#define ENCODER_B_PIN 3
#define SWITCH_PIN    4
long position;

void setup(){

  pinMode(ENCODER_A_PIN, INPUT);
  pinMode(ENCODER_B_PIN, INPUT);
  pinMode(SWITCH_PIN, INPUT);

  attachInterrupt(0, read_quadrature, CHANGE);


  Serial.begin(9600);
}

void loop(){
   if (digitalRead(SWITCH_PIN) == LOW){
     delay(10);
     if (digitalRead(SWITCH_PIN) == LOW){
       Serial.println("Switch Pressed");
     }
   }
   Serial.print("Position: ");
   Serial.println(position, DEC);
   delay(1000);
}

void read_quadrature(){  
 
  if (digitalRead(ENCODER_A_PIN) == LOW){   
    //Check clockwise or counterclockwise
    if (digitalRead(ENCODER_B_PIN) == LOW)
      position++;
  }
  
  else{
 
    if (digitalRead(ENCODER_B_PIN) == LOW)
      position--;
  }
}
